<template>
  <VApp>
    <TheHeader v-if="layout" />

    <VContent>
      <Nuxt v-if="!loading" />
    </VContent>

    <VFooter
      v-if="layout"
      color="primary"
      class="px-3 white--text"
      app
    >
      <small>Copyright © 2019 Leonardo C. Carvalho</small>
      <VSpacer />
      <small>Feito com muito amor <VIcon color="red">fa-heart</VIcon></small>
    </VFooter>

    <!-- message -->
    <VSnackbar
      v-model="snackbar"
      :color="msg.color"
      :timeout="msg.timeout"
      bottom
      multi-line
    >
      {{ msg.message }}
      <VBtn
        v-if="msg.btn"
        icon
        @click="snackbar = false"
      >
        <VIcon>fa-times-circle</VIcon>
      </VBtn>
    </VSnackbar>
  </VApp>
</template>

<script lang="ts">
import {
  Component, Vue, State, Mutation, Watch,
} from 'nuxt-property-decorator';

@Component({
  components: {
    TheHeader: () => import('@/components/layouts/the-header.vue'),
  },
})
export default class Default extends Vue {
  @State
  dark!: boolean

  @State
  layout!: boolean

  @State
  msg!: {
    bool: boolean
  }

  @Mutation
  setLayout!: (key: boolean) => void

  @Mutation
  setBoolMsg!: (bool: boolean) => void

  loading = true

  get snackbar() {
    return this.msg.bool;
  }

  set snackbar(bool: boolean) {
    this.setBoolMsg(bool);
  }

  async mounted() {
    await this.$nextTick();

    this.$nuxt.$loading.start();
    this.setLayout(true);
    this.loading = false;
    this.$vuetify.theme.dark = this.dark;
    this.$nuxt.$loading.finish();
  }

  @Watch('dark')
  changeTheme(bool: boolean) {
    this.$vuetify.theme.dark = this.dark;
  }
}
</script>
